import {useCallback,useState,useEffect} from "react";
import {store} from "../reducers";
import {useDropzone} from "react-dropzone";
import {connect} from "react-redux";
import {actionUploadTrack, actionFindMyTracks, backURL} from "../actions";
import {CPreloaded} from "./preloader";
import {CPlayer} from "./player";
import {actionSetTrackToPlaylist} from "../actions";


const defaultTrack = {
    "_id": "61dc5a42e9472933a6785f18",
    "url": "track/fe15599bbb13c96d70dd5a1591a0b158",
    "originalFileName": "cart.png",
    "owner": {
        "login": "mfdok43"
    }
}








export const PageMain = () =>
    <div>
    <h1>Моя музыка</h1>
        <CTrackDropZone />
        <CPlayer />
    </div>

function TrackDropZone({ onLoad }) {
    const onDrop = useCallback((acceptedFiles) => {
        // Do something with the files
        onLoad(acceptedFiles[0]);
        store.dispatch(actionSetTrackToPlaylist(acceptedFiles[0]))
    }, []);
    const { getRootProps, getInputProps, isDragActive } = useDropzone({ onDrop });

    return (
        <div {...getRootProps()}>
            <input {...getInputProps()} />
            {isDragActive ? (
                <p>Перетащите файл сюда ...</p>
            ) : (
                <p>Для добавления трэка перетащите файлы в плейлист</p>

            )}
           {/*<CPreloaded name='findMyTracks1'>*/}
           {/*   <CMyTracks />*/}
           {/*</CPreloaded>*/}

        </div>
    );

}


export const CTrackDropZone = connect (null, {onLoad: actionUploadTrack}) (TrackDropZone)

store.dispatch(actionFindMyTracks())

