import {applyMiddleware, combineReducers, createStore} from "redux";
import {authReducer} from "./authReducer";
import {promiseReducer,promiseWatcher} from "./promiseReducer";
import {routeReducer, routeWatcher} from "./routeReducer";
import {playerReducer} from "./playerReducer";
import {
    loginWatcher,
    regWatcher,
    setAvatarWatcher,
    aboutMeWatcher,
    findMyTracksWatcher,
    actionAboutMe,
    playlistFindByOwnerWatcher,
    setTrackToPlaylistWatcher,
    actionFindMyTracks,
} from "../actions";
import {localStoredReducer} from "./localStoredReducer";
import createSagaMiddleware from 'redux-saga';
import {all} from 'redux-saga/effects';
import {createPlaylistWatcher} from "../actions";
// import {setUserPasswordWatcher} from "../pages/header/header-build";


const sagaMiddleware = createSagaMiddleware()
export const store = createStore(combineReducers({promise: localStoredReducer(promiseReducer, 'promise'),
                                                             auth: localStoredReducer(authReducer, 'auth'),
                                                           player: localStoredReducer(playerReducer, 'player'),
                                                            route: localStoredReducer(routeReducer,'route')}),
                                                                   applyMiddleware(sagaMiddleware))

// export const store = createStore(combineReducers({promise: promiseReducer,
//         auth: authReducer}),
//     applyMiddleware(sagaMiddleware))


function* rootSaga(){
    yield all([
        promiseWatcher(),
         loginWatcher(),
         regWatcher(),
         setAvatarWatcher(),
         aboutMeWatcher(),
         createPlaylistWatcher(),
         findMyTracksWatcher(),
         routeWatcher(),
          playlistFindByOwnerWatcher(),
          setTrackToPlaylistWatcher(),
         // setUserPasswordWatcher(),
    ])
}
store.dispatch(actionAboutMe())
sagaMiddleware.run(rootSaga)
store.subscribe(() => console.log(store.getState()))

